diff --git a/doc/guix.texi b/doc/guix.texi
index 409ca2ad62..ec36159de1 100644
--- a/doc/guix.texi
+++ b/doc/guix.texi
@@ -4801,9 +4801,11 @@ Invoking guix pull
 @item
 the @option{--channels} option;
 @item
-the user's @file{~/.config/guix/channels.scm} file;
+the user's @file{~/.config/guix/channels.scm} file, unless @option{-q}
+is passed;
 @item
-the system-wide @file{/etc/guix/channels.scm} file;
+the system-wide @file{/etc/guix/channels.scm} file, unless @option{-q}
+is passed;
 @item
 the built-in default channels specified in the @code{%default-channels}
 variable.
@@ -4905,6 +4907,10 @@ Invoking guix pull
 evaluates to a list of channel objects.  @xref{Channels}, for more
 information.
 
+@item -q
+Inhibit loading of the user and system channel files,
+@file{~/.config/guix/channels.scm} and @file{/etc/guix/channels.scm}.
+
 @cindex channel news
 @item --news
 @itemx -N
@@ -5092,18 +5098,26 @@ Invoking guix time-machine
 Read the list of channels from @var{file}.  @var{file} must contain
 Scheme code that evaluates to a list of channel objects.
 @xref{Channels} for more information.
+
+@item -q
+Inhibit loading of the user and system channel files,
+@file{~/.config/guix/channels.scm} and @file{/etc/guix/channels.scm}.
 @end table
 
-As for @command{guix pull}, the absence of any options means that the
-latest commit on the master branch will be used.  The command
+As for @command{guix pull}, in the absence of any options,
+@command{time-machine} fetches the latest commits of the channels
+specified in @file{~/.config/guix/channels.scm},
+@file{/etc/guix/channels.scm}, or the default channels; the @option{-q}
+option lets you ignore these configuration files.  The command:
 
 @example
-guix time-machine -- build hello
+guix time-machine -q -- build hello
 @end example
 
-will thus build the package @code{hello} as defined in the master branch,
-which is in general a newer revision of Guix than you have installed.
-Time travel works in both directions!
+will thus build the package @code{hello} as defined in the main branch
+of Guix, without any additional channel, which is in general a newer
+revision of Guix than you have installed.  Time travel works in both
+directions!
 
 Note that @command{guix time-machine} can trigger builds of channels and
 their dependencies, and these are controlled by the standard build
diff --git a/guix/scripts/pull.scm b/guix/scripts/pull.scm
index ecd264d3fa..f0d4ff36e6 100644
--- a/guix/scripts/pull.scm
+++ b/guix/scripts/pull.scm
@@ -84,6 +84,8 @@ (define (show-help)
 Download and deploy the latest version of Guix.\n"))
   (display (G_ "
   -C, --channels=FILE    deploy the channels defined in FILE"))
+  (display (G_ "
+  -q                     inhibit loading of user and system 'channels.scm'"))
   (display (G_ "
       --url=URL          download \"guix\" channel from the Git repository at URL"))
   (display (G_ "
@@ -133,6 +135,9 @@ (define %options
   (cons* (option '(#\C "channels") #t #f
                  (lambda (opt name arg result)
                    (alist-cons 'channel-file arg result)))
+         (option '(#\q) #f #f
+                 (lambda (opt name arg result)
+                   (alist-cons 'ignore-channel-files? #t result)))
          (option '(#\l "list-generations") #f #t
                  (lambda (opt name arg result)
                    (cons `(query list-generations ,arg)
@@ -735,6 +740,9 @@ (define (channel-list opts)
   (define file
     (assoc-ref opts 'channel-file))
 
+  (define ignore-channel-files?
+    (assoc-ref opts 'ignore-channel-files?))
+
   (define default-file
     (string-append (config-directory) "/channels.scm"))
 
@@ -750,9 +758,11 @@ (define (channel-list opts)
   (define channels
     (cond (file
            (load-channels file))
-          ((file-exists? default-file)
+          ((and (not ignore-channel-files?)
+                (file-exists? default-file))
            (load-channels default-file))
-          ((file-exists? global-file)
+          ((and (not ignore-channel-files?)
+                (file-exists? global-file))
            (load-channels global-file))
           (else
            %default-channels)))
diff --git a/guix/scripts/time-machine.scm b/guix/scripts/time-machine.scm
index d7c71ef705..8afea6b35d 100644
--- a/guix/scripts/time-machine.scm
+++ b/guix/scripts/time-machine.scm
@@ -1,6 +1,6 @@
 ;;; GNU Guix --- Functional package management for GNU
 ;;; Copyright © 2019 Konrad Hinsen <konrad.hinsen@fastmail.net>
-;;; Copyright © 2019, 2020, 2021 Ludovic Courtès <ludo@gnu.org>
+;;; Copyright © 2019, 2020, 2021, 2023 Ludovic Courtès <ludo@gnu.org>
 ;;; Copyright © 2021 Simon Tournier <zimon.toutoune@gmail.com>
 ;;;
 ;;; This file is part of GNU Guix.
@@ -51,6 +51,8 @@ (define (show-help)
 Execute COMMAND ARGS... in an older version of Guix.\n"))
   (display (G_ "
   -C, --channels=FILE    deploy the channels defined in FILE"))
+  (display (G_ "
+  -q                     inhibit loading of user and system 'channels.scm'"))
   (display (G_ "
       --url=URL          use the Git repository at URL"))
   (display (G_ "
@@ -75,6 +77,9 @@ (define %options
   (cons* (option '(#\C "channels") #t #f
                  (lambda (opt name arg result)
                    (alist-cons 'channel-file arg result)))
+         (option '(#\q) #f #f
+                 (lambda (opt name arg result)
+                   (alist-cons 'ignore-channel-files? #t result)))
          (option '("url") #t #f
                  (lambda (opt name arg result)
                    (alist-cons 'repository-url arg